const multer = require('multer');
const { Helpers } = require('./helpers');
const storage = multer.diskStorage({
    destination: function(req, file, cb) {
        const path = `${process.env.UPLOAD_PATH}`
        cb(null, path);
    },
    filename: function(req, file, cb) {
        cb(null, `${+new Date}_${file.originalname}`);
    }
});
const upload = multer({
    storage: storage,
    fileFilter: function(req, file, cb) {
        Helpers.fileType(file, cb)
    }
})

module.exports = upload