const { Helpers } = require('../controller/helpers');
const { LoginModel, ExtraModel } = require('../controller/index')

module.exports = async function (req, res) {
    const REQUIRED = ['username', 'password', 'device', 'browser', 'os', 'ip'];
    const FIELDS_GET = Object.keys(req.body)

    if (REQUIRED.isEqualArray(FIELDS_GET)) {
        const { username, password, device, browser, os, ip } = req.body
        const create = {
            username,
            password: password.md5()
        }
        const result = await LoginModel.authenticate(create)
        if (result.length > 0) {
            ExtraModel.logEvent('USER_LOGIN_SUCCESS', `${username} logged in to the system.`, result[0].user_id, ip, device, browser, os)
            delete result[0].user_id
            return res.status(200).json(Helpers.sendResponse("success", result, `User Login`))
        }
        ExtraModel.logEvent('USER_LOGIN_FAILED', `Someone tried to login using username ${username}.`, null, ip, device, browser, os)
        return res.status(401).json(Helpers.sendResponse("fail", [], "Invalid Username and Password"))
    } else {
        ExtraModel.logEvent('USER_LOGIN_FAILED', `Someone probably tried to login via API. API is probably in wrong hands.`)
        return res.status(400).json(Helpers.sendResponse("fail", [], `Key Mismatch ${REQUIRED.join(",")}`))
    }
}